import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:qr_code_scanner/qr_code_scanner.dart';

class QrCodeView extends StatefulWidget {

  @override
  QrCodeViewState createState() => QrCodeViewState();
}

class QrCodeViewState extends State<QrCodeView> {

  static final String QRcancelMsg = "canceled";

  final GlobalKey qrKey = GlobalKey(debugLabel: 'QRView');

  QRViewController controller;

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {

    return Scaffold(
      backgroundColor: Theme.of(context).primaryColor,
      body: Column(
        children: <Widget>[
          Expanded(
            flex: 10,
            child: Stack(
              children: <Widget>[
                QRView(
                  key: qrKey,
                  onQRViewCreated: _onQRViewCreated,
                ),
                Container(
                  alignment: Alignment.topLeft,
                  child: IconButton(
                    icon: Icon(Icons.arrow_back_ios, color: Colors.white,),
                    onPressed: (){ Navigator.pop(context, QRcancelMsg); },
                  ),
                ),
              ],
            ),
          ),
        ],
      ),
    );
  }

  @override
  void dispose() {
    controller.dispose();
    super.dispose();
  }

  void _onQRViewCreated(QRViewController controller) {
    this.controller = controller;
    bool flag = true;
    controller.scannedDataStream.listen((scanData){
      if (flag){
        flag = false;
        Navigator.pop(context, scanData);
      }
    });
  }
}

Future<String> openScanner(BuildContext context) async {
  return await Navigator.push(
    context,
    MaterialPageRoute(builder: (context) => QrCodeView()),
  );
}
